from buils.BaseBuild import BaseBuild
from buils.BuildConfig import BuildConfig
from buils.DefinedBuild import initiate_build, BUILDS_ENABLED
from managers.BuildDataManager import BuildDataManager
from managers.data_manager import DataManager
from micro.generic_micro import GenericMicro
from micro.micro_overseer import MicroOverseers
from micro.micro_ravagers import MicroRavagers
from micro.micro_vipers import MicroVipers
from micro.micro_zerglings import MicroZerglings
from micro.unit_value import MyUnitValue
from randomizer import WeightedRandomizer
from sc2 import Race, UnitTypeId, Optional, List
from sharpy.knowledges import KnowledgeBot
from sharpy.managers import ManagerBase
from sharpy.plans.zerg import *
import random


class RoachRunner(KnowledgeBot):
    def __init__(self):
        lines = ["Derg the Zerg is back"]
        super().__init__(random.choice(lines))

        self.knowledge.unit_values = MyUnitValue()
        # self.knowledge.data_manager = DataManager()

        # self.knowledge.build_data_manager = BuildDataManager()

    # def configure_managers(self) -> Optional[List[ManagerBase]]:
        # self.knowledge.roles.set_tag_each_iteration = True
        # return [self.knowledge.build_data_manager]

    async def on_start(self):

        #self.knowledge.managers.remove(self.knowledge.data_manager)
        #self.knowledge.managers.remove(self.knowledge.unit_values)

        #self.knowledge.managers.append(self.knowledge.data_manager)
        #self.knowledge.managers.append(self.knowledge.unit_values)

        self.knowledge.combat_manager.default_rules.generic_micro = GenericMicro()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.OVERSEER] = MicroOverseers()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.RAVAGER] = MicroRavagers()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.VIPER] = MicroVipers()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.ZERGLING] = MicroZerglings()

        await super().on_start()

    def get_build(self):
        """
        builds =  BUILDS_ENABLED # ["lings", "ravager", "hydra", "lurker", "roachydra-to-lurkers", "roach-to-hydra", "lingbane-to-lurkers"]
        stats_for_builds, stats_for_builds_vs_enemy = self.knowledge.data_manager.load_statistics(builds)
        prob_of_choise = {}
        for build in builds:
            if not stats_for_builds[build][self.knowledge.enemy_race]:
                # prob_of_choise[build] = 0.5
                continue
            total_w = stats_for_builds[build][self.knowledge.enemy_race]["win"]
            total_l = stats_for_builds[build][self.knowledge.enemy_race]["lose"]
            total = total_w + total_l

            if not stats_for_builds_vs_enemy[build][self.knowledge.enemy_race]:

                if total <= 0:
                    prob_of_choise[build] = 0.5
                else:
                    prob_of_choise[build] = (0.1 + total_w) / total
                continue

            stotal_w = stats_for_builds_vs_enemy[build][self.knowledge.enemy_race]["win"]
            stotal_l = stats_for_builds_vs_enemy[build][self.knowledge.enemy_race]["lose"]
            stotal = stotal_w + stotal_l

            self.knowledge.print(str(stotal_w) + " " + str(stotal_l) + " " + str(stotal))

            if total <= 0:
                prob_of_choise[build] = 0.3
            elif stotal < 1:
                prob_of_choise[build] = (0.1 + total_w) / total
            elif stotal >= 1:
                prob_of_choise[build] = (0.1 + stotal_w) / stotal

            # Heavily weigh the differences
            prob_of_choise[build] = pow(prob_of_choise[build], 4)

        self.knowledge.print("Chanse of builds: " + ', '.join([p + " " + str(v) for p, v in prob_of_choise.items()]))

        build = WeightedRandomizer(prob_of_choise).random()
        """
        build = "ravager"
        self.knowledge.print("Build chosen: " + build)
        self.knowledge.build_config = BuildConfig()

        return initiate_build(build, self.knowledge), build

    async def create_plan(self) -> BuildOrder:
        bo, name = self.get_build()
        self.knowledge.build = name

        builds = []
        for key in BUILDS_ENABLED:
            builds.append(
                Step(None, initiate_build(key, self.knowledge),
                     skip_until=lambda k, key=key: self.knowledge.build == key
                     )
            )

        return BuildOrder(builds, BaseBuild().build(self.knowledge))

"""
    async def create_plan(self) -> BuildOrder:
        bo, name = self.get_build()
        self.knowledge.build = name


        await self.knowledge.chat_manager.chat_debug('Chose build ' + name)
        return bo
        #return BuildDecisionAct(self.knowledge)
"""

"""
Do this at some point
"""

class LadderBot(RoachRunner):
    @property
    def my_race(self):
        return Race.Zerg
