
from buils.DefinedBuild import initiate_build
from micro.generic_micro import GenericMicro
from micro.micro_overseer import MicroOverseers
from micro.micro_ravagers import MicroRavagers
from micro.micro_vipers import MicroVipers
from micro.unit_value import MyUnitValue
from plans.MyDistributeWorkers import MyDistributeWorkers
from plans.PlanZoneCounterAttack import PlanZoneCounterAttack
from plans.viper_energy import ViperEnergy
from sc2 import UnitTypeId, AIBuild
from sharpy.knowledges import KnowledgeBot
from sharpy.plans.zerg import *

class Test_bot(KnowledgeBot):
    def __init__(self):
        super().__init__("The purge has arrived")

        self.knowledge.unit_values = MyUnitValue()

    async def on_start(self):
        # self.knowledge.managers.remove(self.knowledge.data_manager)
        # self.knowledge.managers.remove(self.knowledge.unit_values)

        # self.knowledge.managers.append(self.knowledge.data_manager)
        # self.knowledge.managers.append(self.knowledge.unit_values)

        self.knowledge.combat_manager.default_rules.generic_micro = GenericMicro()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.OVERSEER] = MicroOverseers()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.RAVAGER] = MicroRavagers()
        self.knowledge.combat_manager.default_rules.unit_micros[UnitTypeId.VIPER] = MicroVipers()

        await super().on_start()

        """
        await self.knowledge.ai.client.debug_create_unit(
            [
                [UnitTypeId.SIEGETANK, 5, self.knowledge.ai.game_info.map_center.position, 2],
                [UnitTypeId.VIPER, 3, self.knowledge.ai.game_info.map_center.position, 1],
                [UnitTypeId.EVOLUTIONCHAMBER, 2, self.knowledge.expansion_zones[1].center_location, 1],
            ]
        )
        """
        """
        await self.knowledge.ai.client.debug_create_unit(
            [
                [UnitTypeId.BATTLECRUISER, 2, self.knowledge.expansion_zones[0].center_location, 2],
                [UnitTypeId.QUEEN, 3, self.knowledge.expansion_zones[1].center_location, 1],
                [UnitTypeId.HATCHERY, 1, self.knowledge.expansion_zones[1].center_location, 1],
                [UnitTypeId.DRONE, 10, self.knowledge.expansion_zones[1].center_location, 1],
                [UnitTypeId.SPORECRAWLER, 1, self.knowledge.expansion_zones[0].center_location, 1],
            ]
        )
        """

    async def create_plan(self) -> BuildOrder:
        zone_defence = PlanZoneDefense()
        zone_attack = PlanZoneAttack()
        return BuildOrder(initiate_build("hydra", self.knowledge), SequentialList(
            MyDistributeWorkers(),
            SpreadCreep(),
            InjectLarva(),
            ViperEnergy(),
            zone_defence,
            PlanZoneCounterAttack(zone_defence, zone_attack),
            zone_attack,
        ))


"""
Do this at some point
"""


class LadderBot(Test_bot):
    @property
    def my_race(self):
        return Race.Zerg


import sc2
from sc2 import Race, Difficulty
from sc2.player import Bot, Computer


bot = Bot(Race.Zerg, LadderBot())

# Start game
if __name__ == "__main__":
    # Local game
    print("Starting local game...")
    enemy = Computer(Race.Terran, Difficulty.VeryHard, AIBuild.Timing)
    sc2.run_game(sc2.maps.get("AcropolisLE"), [bot, enemy], realtime=False)
