from plans.LingScoutAllExpos import LingScoutAllExpos
from plans.surrender_plan import SurrenderPlan
from sc2 import UnitTypeId, Race

from buils.build import Build
from plans.FirstOvieScout import FirstOvieScout
from plans.MyDistributeWorkers import MyDistributeWorkers
from plans.OvieScout import OvieScout
from plans.PlanZoneCounterAttack import PlanZoneCounterAttack
from plans.SecondOvieScout import SecondOvieScout
from plans.mine_mineral_wall import MineMineralWall
from plans.simple_ling_scout import SimpleLingScout
from plans.viper_energy import ViperEnergy
from sharpy.plans.zerg import *
from sharpy.plans.tactics import PlanZoneDefense


class BaseBuild(Build):
    def build(self, knowledge: "Knowledge") -> SequentialList:
        zone_defence = PlanZoneDefense()
        zone_attack = PlanZoneAttack()
        knowledge.zone_attack = zone_attack
        return SequentialList(
            SurrenderPlan(),
            PlanZoneDefense(),
            Step(None, FirstOvieScout(), skip_until=Time(30), skip=RequireCustom(lambda k: k.enemy_race != Race.Zerg)),
            Step(None, SecondOvieScout(), skip_until=Time(2*60)),
            Step(None, OvieScout(), skip_until=Time(4*60)),
            Step(None, LingScoutAllExpos(), skip_until=Time(1*60)),
            Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(3 * 60), skip=RequireCustom(lambda k: k.enemy_race != Race.Zerg)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(4 * 60)),
            Step(None, SimpleLingScout(knowledge.expansion_zones[-3]), skip_until=Time(4 * 60)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(5 * 60)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(6 * 60)),
            Step(None, SimpleLingScout(knowledge.expansion_zones[-4]), skip_until=Time(6 * 60)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(8 * 60)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(10 * 60)),
            Step(None, SimpleLingScout(knowledge.expansion_zones[-5]), skip_until=Time(8 * 60)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(12 * 60)),
            #Step(None, SimpleLingScout(knowledge.expansion_zones[-1]), skip_until=Time(14 * 60)),
            PlanCancelBuilding(),
            PlanZoneGather(),
            Step(None, WorkerScout(), skip_until=Supply(16)),
            InjectLarva(),
            Step(None, SpreadCreep(), skip_until=UnitReady(UnitTypeId.QUEEN, 3)),
            ViperEnergy(),
            MyDistributeWorkers(),
            zone_defence,
            PlanZoneCounterAttack(zone_defence, zone_attack),
            zone_attack,
            PlanFinishEnemy(),
            Step(None, MineMineralWall(), skip_until=Time(6*60)),
        )

