from buils.early.Eco_build import EcoBuild
from buils.early.late_gas import LateGas
from buils.early.normal_macro import NormalMacro
from buils.lategame.BroodLords import BroodLordBuild
from buils.lategame.LategameHydra import LategameHydra
from buils.lategame.LategameRavager import LategameRavager
from buils.lategame.lurkers import LurkersBuild
from buils.midgame.earlyHydra import EarlyHydra
from buils.midgame.lingbane import LingBaneBuild
from buils.midgame.roachhydra import RoachHydra
from buils.midgame.roachplay import RoachPlay
from buils.old.LingCheeze import LingCheeze
from buils.old.MutaLingBane import MutaLingBane
from buils.BuildDecisionAct import BuildDecisionAct
from buils.midgame.spireBuild import SpireBuild
from plans.viper_energy import ViperEnergy
from sharpy.plans.zerg import *

BUILDS_ENABLED = [
    #"lings",
    "ravager",
    "hydra",
    "lurker",
    "roachydra-to-lurkers",
    "lingbane-to-lurkers",
    "roach-to-hydra",
    "spire-build",
]

def initiate_build(build, knowledge):
    bo = None
    if build == "lings":
        bo = BuildOrder(
            CounterTerranTie([LingCheeze()]),
            PlanCancelBuilding(),
            PlanZoneAttack(start_attack_power=0),
            InjectLarva(),
            PlanFinishEnemy(),
        )
    if build == "ravager":
        bo = BuildDecisionAct(knowledge, LateGas(), RoachPlay(), LategameRavager())

    if build == "hydra":
        bo = BuildDecisionAct(knowledge, NormalMacro(), RoachHydra(), LategameHydra())

    if build == "lurker":
        bo = BuildDecisionAct(knowledge, NormalMacro(), EarlyHydra(), LurkersBuild())

    if build == "roachydra-to-lurkers":
        bo = BuildDecisionAct(knowledge, NormalMacro(), RoachHydra(), LurkersBuild())

    if build == "lingbane-to-lurkers":
        bo = BuildDecisionAct(knowledge, NormalMacro(), LingBaneBuild(), LurkersBuild())

    if build == "roach-to-hydra":
        bo = BuildDecisionAct(knowledge, NormalMacro(), RoachPlay(), LategameHydra())

    if build == "spire-build":
        bo = BuildDecisionAct(knowledge, EcoBuild(), SpireBuild(), BroodLordBuild())

    if build == "mutalingbane":
        bo = BuildOrder(
            CounterTerranTie([MutaLingBane()]),
            SequentialList(
                PlanZoneDefense(),
                OverlordScout(),
                Step(None, LingScoutMain(), skip_until=Time(4 * 60)),
                Step(None, LingScoutMain(), skip_until=Time(8 * 60)),
                PlanCancelBuilding(),
                PlanZoneGather(),
                Step(None, WorkerScout(), skip_until=RequiredSupply(18)),
                SpreadCreep(),
                InjectLarva(),
                ViperEnergy(),
                PlanDistributeWorkers(),
                PlanZoneAttack(),
                PlanFinishEnemy(),
            ),
        )
    return bo
