from buils.build import Build
from buils.util import build_workers
from sc2 import UnitTypeId
from sharpy.plans.zerg import *
from plans.step_gas import StepBuildGas


class LateGas(Build):
    def build(self):
        return SequentialList(
            # Opener
            Step(Supply(17), Expand(2)),
            Step(
                Supply(17),
                PositionBuilding(UnitTypeId.SPAWNINGPOOL, DefensePosition.BehindMineralLineLeft, 0),
            ),
            ActUnit(UnitTypeId.ZERGLING, UnitTypeId.LARVA, 4),
            ZergUnit(UnitTypeId.QUEEN, 2),
            Step(
                None,
                StepBuildGas(1),
                skip_until=UnitExists(UnitTypeId.DRONE, 22, include_pending=True)
            ),
            Step(
                None,
                StepBuildGas(2),
                skip_until=UnitExists(UnitTypeId.DRONE, 28, include_pending=True)
            ),
            Step(build_workers, None, skip=Time(5 * 60)),
            Step(Supply(30), Expand(3)),
            ZergUnit(UnitTypeId.QUEEN, 4),
        )

    def units(self):
        return SequentialList(
            ZergUnit(UnitTypeId.ZERGLING)
        )
