from buils.build import Build
from buils.util import build_workers
from sc2 import UnitTypeId
from sharpy.plans.zerg import *
from plans.act_expand import ActExpand
from plans.step_gas import StepBuildGas


class NormalMacro(Build):
    def build(self):
        return SequentialList(
            # Opener
            Step(RequiredSupply(17), ActExpand(2)),
            Step(
                RequiredSupply(17),
                PositionBuilding(UnitTypeId.SPAWNINGPOOL, DefensePosition.BehindMineralLineLeft, 0),
            ),
            StepBuildGas(1, RequiredSupply(16)),
            ActUnit(UnitTypeId.ZERGLING, UnitTypeId.LARVA, 4),
            ZergUnit(UnitTypeId.QUEEN, 2),
            Step(
                None,
                StepBuildGas(4),
                skip_until=UnitExists(UnitTypeId.DRONE, 40, include_pending=True)
            ),
            Step(build_workers, None, skip=Time(5 * 60)),
            Step(RequiredSupply(30), ActExpand(3)),
            ZergUnit(UnitTypeId.QUEEN, 4),
        )

    def units(self):
        return SequentialList(
            ZergUnit(UnitTypeId.ZERGLING)
        )

