from buils.early.defenceRoaches import RoachLings
from sc2.ids.upgrade_id import UpgradeId

from buils.build import Build
from buils.util import build_workers, is_not_earlygame
from sc2 import UnitTypeId
from sharpy.plans.zerg import *
from plans.step_gas import StepBuildGas


class Turtle(Build):
    def build(self):
        return SequentialList(
            # Opener
            Step(
                Supply(17),
                PositionBuilding(UnitTypeId.SPAWNINGPOOL, DefensePosition.BehindMineralLineLeft, 0),
            ),
            StepBuildGas(1, Supply(17)),
            Step(
                All([UnitReady(UnitTypeId.SPAWNINGPOOL), UnitReady(UnitTypeId.HATCHERY, 2)]),
                PositionBuilding(UnitTypeId.SPINECRAWLER, DefensePosition.Entrance, to_count=2, to_base_index=1)
            ),
            Step(None, PositionBuilding(UnitTypeId.SPORECRAWLER, DefensePosition.Entrance, to_count=1, to_base_index=1), skip=Time(5*60), skip_until=EnemyUnitExists(UnitTypeId.ROACHWARREN)),
            ZergUnit(UnitTypeId.QUEEN, 2),
            Step(
                UnitReady(UnitTypeId.SPAWNINGPOOL),
                ActUnit(UnitTypeId.ZERGLING, UnitTypeId.LARVA, 4),
            ),
            Step(All([UnitReady(UnitTypeId.SPAWNINGPOOL), Gas(50)]), ActBuilding(UnitTypeId.ROACHWARREN)),
            Step(None, Tech(UpgradeId.ZERGLINGMOVEMENTSPEED), skip_until=Gas(200)),
            Step(None, ZergUnit(UnitTypeId.ROACH, 6), skip=RequireCustom(lambda k: len(k.unit_cache.own(UnitTypeId.ROACHWARREN).ready) == 0 or k.ai.time > 5*60)),
            Step(UnitReady(UnitTypeId.ROACHWARREN), RoachLings(), skip=Time(5*60)),
            Step(build_workers, None, skip=Time(5 * 60)),
            ZergUnit(UnitTypeId.QUEEN, 4),
            StepBuildGas(3, UnitReady(UnitTypeId.DRONE, 34)),
        )

    def units(self):
        return SequentialList(
            ZergUnit(UnitTypeId.ZERGLING)
        )

