from buils.old.RoachHydra import RoachAndHydras
from buils.build import Build
from buils.util import build_workers, ranged_upgrades
from sc2 import UnitTypeId
from sc2.ids.upgrade_id import UpgradeId
from sharpy.plans.zerg import *


class LategameHydra(Build):
    def build(self):
        return SequentialList(
            # Tech
            Step(build_workers, None, skip=Time(8 * 60)),
            Step(RequiredUnitReady(UnitTypeId.SPAWNINGPOOL), ActBuilding(UnitTypeId.ROACHWARREN), skip=UnitExists(UnitTypeId.ROACHWARREN)),
            Step(None, ActBuilding(UnitTypeId.HYDRALISKDEN)),
            Step(RequiredUnitReady(UnitTypeId.HYDRALISKDEN), ActTech(UpgradeId.EVOLVEMUSCULARAUGMENTS)),
            Step(RequiredUnitReady(UnitTypeId.HYDRALISKDEN), ActTech(UpgradeId.EVOLVEGROOVEDSPINES)),
            ActBuilding(UnitTypeId.INFESTATIONPIT),
            MorphHive(),
        )

    def tech(self) -> SequentialList:
        return SequentialList(
            # Upgrades after a while
            Step(build_workers, None, skip=Time(8 * 60)),
            MorphHive(),
            Step(Time(60 * 6), ActBuilding(UnitTypeId.EVOLUTIONCHAMBER, to_count=2)),
            ranged_upgrades,
        )

    def units(self):
        return SequentialList(
            Step(None, ZergUnit(UnitTypeId.VIPER, 4), skip_until=RequiredUnitReady(UnitTypeId.INFESTATIONPIT)),
            Step(None, ZergUnit(UnitTypeId.INFESTOR, 4), skip_until=RequiredUnitReady(UnitTypeId.INFESTATIONPIT)),
            Step(None, ZergUnit(UnitTypeId.HYDRALISK), skip_until=All([Time(15*60), RequiredUnitReady(UnitTypeId.HYDRALISKDEN)])),
            Step(None, RoachAndHydras(), skip_until=RequiredUnitReady(UnitTypeId.HYDRALISKDEN)),
            Step(None, ZergUnit(UnitTypeId.ROACH), skip_until=RequiredUnitReady(UnitTypeId.ROACHWARREN)),
            Step(None, ZergUnit(UnitTypeId.ZERGLING), skip=RequiredUnitReady(UnitTypeId.HYDRALISKDEN)),
        )
