from buils.build import Build
from buils.midgame.roachplay import RoachAndRavager
from buils.util import build_workers, ranged_upgrades
from sc2 import UnitTypeId
from sharpy.plans.zerg import *


class LategameRavager(Build):
    def build(self):
        return SequentialList(
            Step(UnitReady(UnitTypeId.SPAWNINGPOOL), ActBuilding(UnitTypeId.ROACHWARREN), skip=UnitExists(UnitTypeId.ROACHWARREN)),
        )

    def tech(self) -> SequentialList:
        return SequentialList(
            # Upgrades after a while
            Step(build_workers, None, skip=Time(8 * 60)),
            MorphHive(),
            Step(None, ActBuilding(UnitTypeId.EVOLUTIONCHAMBER, to_count=2)),
            ranged_upgrades,
        )

    def units(self):
        return SequentialList(
            Step(None, RoachAndRavager(), skip_until=UnitReady(UnitTypeId.ROACHWARREN)),
            ZergUnit(UnitTypeId.ZERGLING)
        )
