from typing import Union, Callable, List

from sc2 import UnitTypeId, Race
from sc2.ids.upgrade_id import UpgradeId
from sc2.unit import Unit
from sharpy.knowledges import KnowledgeBot, Knowledge
from sharpy.plans.acts.expand import Expand
from sharpy.plans.zerg import *


class LingCheeze(BuildOrder):
    def __init__(self):
        super().__init__(
            SequentialList(
                # Opener
                ZergUnit(UnitTypeId.DRONE, 14),
                Step(
                    None,
                    PositionBuilding(UnitTypeId.SPAWNINGPOOL, DefensePosition.BehindMineralLineLeft, 0),
                ),
                Step(None, Expand(2)),
                Step(UnitExists(UnitTypeId.DRONE, 13), ZergUnit(UnitTypeId.OVERLORD, 2, priority=True)),
                ZergUnit(UnitTypeId.QUEEN, 1),
            ),
            SequentialList(
                # Overlords
                #Step(UnitExists(UnitTypeId.DRONE, 13), ZergUnit(UnitTypeId.OVERLORD, 2, priority=True)),
                AutoOverLord(),
            ),
            Step(None, ZergUnit(UnitTypeId.ZERGLING)),
        )

class CreepCheep(BuildOrder):
    def __init__(self):
        super().__init__(
            SequentialList(
                # Opener
                Step(
                    None,
                    PositionBuilding(UnitTypeId.SPAWNINGPOOL, DefensePosition.BehindMineralLineLeft, 0),
                ),
            ),
            SequentialList(
                # Overlords
                #Step(UnitExists(UnitTypeId.DRONE, 13), ZergUnit(UnitTypeId.OVERLORD, 2, priority=True)),
                AutoOverLord(),
            ),
            Step(None, ZergUnit(UnitTypeId.ZERGLING)),
        )
