from sc2 import UnitTypeId, AbilityId
from sc2.ids.upgrade_id import UpgradeId
from sc2.unit import Unit
from sharpy.managers import UnitValue


class MyUnitValue(UnitValue):

    def ground_range(self, unit: Unit) -> float:
        if unit.type_id == UnitTypeId.RAVEN and unit.energy >= 50:
            return 9
        if unit.type_id == UnitTypeId.ORACLE:
            return 4
        if unit.type_id == UnitTypeId.CARRIER:
            return 8
        if unit.type_id == UnitTypeId.BATTLECRUISER:
            return 6
        if unit.type_id == UnitTypeId.DISRUPTOR:
            return 10
        if unit.type_id == UnitTypeId.COLOSSUS:
            if not unit.is_mine:
                return 9  # Let's assume the worst, enemy has the upgrade!

            if self.ai.already_pending_upgrade(UpgradeId.EXTENDEDTHERMALLANCE) >= 1:
                return 9
            else:
                return 7
        if unit.type_id == UnitTypeId.CYCLONE:
            if not unit.is_mine or self.knowledge.cooldown_manager.is_ready(unit.tag, AbilityId.LOCKON_LOCKON):
                return 7
            if self.knowledge.cooldown_manager.is_ready(unit.tag, AbilityId.CANCEL_LOCKON):
                return 13

        if unit.type_id == UnitTypeId.OVERSEER:
            return 1
        if unit.type_id == UnitTypeId.LURKER:
            return 8
        if unit.type_id == UnitTypeId.BANELING:
            return 0.1

        return unit.ground_range
