from typing import List, Optional

from sc2.position import Point2
from sc2.units import Units
from sharpy.general.zone import Zone
from sharpy.managers.roles import UnitTask
from sharpy.plans.acts import ActBase
from sc2 import UnitTypeId, AbilityId
from sc2.ids.buff_id import BuffId
from sc2.unit import Unit


class ViperEnergy(ActBase):

    def __init__(self):
        self.consuming = dict()

    async def execute(self) -> bool:
        vipers = self.cache.own(UnitTypeId.VIPER)

        for viper in vipers:
            if viper.energy_percentage < 20 or (viper.is_idle and viper.energy_percentage < 80):
                buildings = self.cache.own \
                    ([UnitTypeId.EXTRACTOR, UnitTypeId.HATCHERY, UnitTypeId.EVOLUTIONCHAMBER]) \
                    .tags_not_in(self.consuming) \
                    .filter(lambda b: b.health > min((viper.energy_max - viper.energy) * 4, 200))

                building = None
                if len(buildings) > 0:
                    building = buildings.closest_to(viper.position)

                if not building:
                    return True

                self.consuming[viper.tag] = building.tag
                self.knowledge.roles.set_task(UnitTask.Reserved, viper)
                self.do(viper(AbilityId.VIPERCONSUMESTRUCTURE_VIPERCONSUME, target=building))
            else:
                if viper.tag in self.consuming:
                    del self.consuming[viper.tag]
                    self.knowledge.roles.set_task(UnitTask.Idle, self.knowledge.unit_cache.by_tag(viper.tag))
        return True
